---
title: Bounding volume collision detection with THREE.js
slug: >-
  Games/Techniques/3D_collision_detection/Bounding_volume_collision_detection_with_THREE.js
tags:
  - 3D
  - Games
  - JavaScript
  - WebGL
  - bounding boxes
  - collision detection
  - three.js
---
<div>{{GamesSidebar}}</div>

<p class="summary">This article shows how to implement <strong>collision detection between bounding boxes and spheres using the Three.js</strong> library. It is assumed that before reading this you have read our <a href="/en-US/docs/Games/Techniques/3D_collision_detection">3D collision detection</a> introductory article first, and have basic knowledge about Three.js.</p>

<h2 id="Using_Box3_and_Sphere">Using <code>Box3</code> and <code>Sphere</code></h2>

<p>Three.js has objects that represent <strong>mathematical volumes</strong> and shapes — for 3D AABB and bounding spheres we can use the <strong><code><a href="https://threejs.org/docs/#api/math/Box3">Box3</a></code></strong> and <strong><code><a href="https://threejs.org/docs/#api/math/Sphere">Sphere</a></code></strong> objects. Once instantiated, they have methods available to do intersection tests against other volumes.</p>

<h3 id="Instantiating_boxes">Instantiating boxes</h3>

<p>To create a <strong><code>Box3</code> instance</strong>, we need to provide the <strong>lower and upper boundaries</strong> of the box. Usually we will want this AABB to be "linked" to an object in our 3D world (like a character.) In Three.js, <code>Geometry</code> instances have a <code>boundingBox</code> property with <code>min</code> and <code>max</code> boundaries for the object. Keep in mind that in order for this property to be defined, you need to manually call <code>Geometry.computeBoundingBox</code> beforehand.</p>

<pre class="brush: js notranslate">var knot = new THREE.Mesh(
  new THREE.TorusKnotGeometry(0.5, 0.1),
  new MeshNormalMaterial({}));

knot.geometry.computeBoundingBox();
var knotBBox = new Box3(
  knot.geometry.boundingBox.min,
  knot.geometry.boundingBox.max);
</pre>

<div class="note">
<p><strong>Note</strong>: The <code>boundingBox</code> property takes the <code>Geometry</code> itself as reference, and not the <code>Mesh</code>. So any transformations such as scale, position, etc. applied to the <code>Mesh</code> will be ignored while computing the calculating box.</p>
</div>

<p>A more simple alternative that fixes the previous issue is to set those boundaries later on with <code>Box3.setFromObject</code>, which will compute the dimensions taking into account a 3D entity's<strong> transformations <em>and</em> any child meshes</strong> as well.</p>

<pre class="brush: js notranslate">var knot = new THREE.Mesh(
  new THREE.TorusKnotGeometry(0.5, 0.1),
  new MeshNormalMaterial({}));

var knotBBox = new Box3(new THREE.Vector3(), new THREE.Vector3());
knotBBox.setFromObject(knot);</pre>

<h3 id="Instantiating_spheres">Instantiating spheres</h3>

<p>Instantiating<strong> <code>Sphere</code> objects</strong> is similar. We need to provide the sphere's center and radius, which can be added to the <code>boundingSphere</code> property available in <code>Geometry</code>.</p>

<pre class="brush: js notranslate">var knot = new THREE.Mesh(
  new THREE.TorusKnotGeometry(0.5, 0.1),
  new MeshNormalMaterial({}));

var knotBSphere = new Sphere(
  knot.position,
  knot.geometry.boundingSphere.radius);
</pre>

<p>Unfortunately, there is no equivalent of <code>Box3.setFromObject</code> for Sphere instances. So if we apply transformations or change the position of the <code>Mesh</code>, we need to manually update the bounding sphere. For instance:</p>

<pre class="notranslate">knot.scale.set(2, 2, 2);
knotBSphere.radius = knot.geometry.radius * 2;
</pre>

<h3 id="Intersection_tests">Intersection tests</h3>

<h4 id="Point_vs._Box3_Sphere">Point vs. <code>Box3</code> / <code>Sphere</code></h4>

<p>Both <code>Box3</code> and <code>Sphere</code> have a <strong><code>containsPoint</code></strong> method to do this test.</p>

<pre class="brush: js notranslate">var point = new THREE.Vector3(2, 4, 7);
knotBBox.containsPoint(point);</pre>

<h4 id="Box3_vs._Box3"><code>Box3</code> vs. <code>Box3</code></h4>

<p>The <strong><code>Box3.intersectsBox</code></strong> method is available for performing this test.</p>

<pre class="brush: js notranslate">knotBbox.intersectsBox(otherBox);</pre>

<div class="note">
<p><strong>Note</strong>: This is different from the <code>Box3.containsBox</code> method, which checks whether the Box3 <em>fully</em> wraps another one.</p>
</div>

<h4 id="Sphere_vs._Sphere"><code>Sphere</code> vs. <code>Sphere</code></h4>

<p>In a similar fashion as before, there is a <code><strong>Sphere.intersectsSphere</strong></code> method to perform this test.</p>

<pre class="brush: js notranslate">knotBSphere.intersectsSphere(otherSphere);</pre>

<h4 id="Sphere_vs._Box3"><code>Sphere</code> vs. <code>Box3</code></h4>

<p>Unfortunately this test is not implemented in Three.js, but we can patch Sphere to implement a <a href="/en-US/docs/Games/Techniques/3D_collision_detection">Sphere vs. AABB intersection</a> algorithm.</p>

<pre class="brush: js notranslate">// expand THREE.js Sphere to support collision tests vs Box3
// we are creating a vector outside the method scope to
// avoid spawning a new instance of Vector3 on every check

THREE.Sphere.__closest = new THREE.Vector3();
THREE.Sphere.prototype.intersectsBox = function (box) {
    // get box closest point to sphere center by clamping
    THREE.Sphere.__closest.set(this.center.x, this.center.y, this.center.z);
    THREE.Sphere.__closest.clamp(box.min, box.max);

    var distance =  this.center.distanceToSquared(THREE.Sphere.__closest);
    return distance &lt; (this.radius * this.radius);
};</pre>

<h3 id="Demos">Demos</h3>

<p>We have prepared some <a href="https://mozdevs.github.io/gamedev-js-3d-aabb/">live demos</a> to demonstrate these techniques, with <a href="https://github.com/mozdevs/gamedev-js-3d-aabb">source code</a> to examine.</p>

<ul>
 <li><a href="https://mozdevs.github.io/gamedev-js-3d-aabb/raw_point.html">Point vs. Box and Sphere</a></li>
 <li><a href="https://mozdevs.github.io/gamedev-js-3d-aabb/raw_box.html">Box vs. Box and Sphere</a></li>
 <li><a href="https://mozdevs.github.io/gamedev-js-3d-aabb/raw_sphere.html">Sphere vs. Box and Sphere</a></li>
</ul>

<p><img alt="" src="https://mdn.mozillademos.org/files/11825/Screen%20Shot%202015-10-20%20at%2015.19.16.png" style="display: block; height: 256px; margin: 0px auto; width: 256px;"></p>

<h2 id="Using_BoxHelper">Using <code>BoxHelper</code></h2>

<p>As an alternative to using raw <code>Box3</code> and <code>Sphere</code> objects, Three.js has a useful object to make handling <strong>bounding boxes easier: <code><a href="https://threejs.org/docs/#api/helpers/BoxHelper">BoxHelper</a></code></strong><strong> </strong>(previously <code>BoundingBoxHelper</code>, which has been deprecated). This helper takes a <code>Mesh</code> and calculates a bounding box volume for it (including its child meshes). This results in a new box <code>Mesh</code> representing the bounding box, which shows the bounding box's shape, and can passed to the previously seen <code>setFromObject</code> method in order to have a bounding box matching the <code>Mesh</code>.</p>

<div>
<p><code>BoxHelper</code> is the <strong>recommended</strong> way to handle 3D collisions with bounding volumes in Three.js. You will miss sphere tests, but the tradeoffs are well worth it.</p>
</div>

<p>The advantages of using this helper are:</p>

<ul>
 <li>It has an <code>update()</code> method that will <strong>resize</strong> its bounding box Mesh if the linked Mesh rotates or changes its dimensions, and update its <strong>position</strong>.</li>
 <li>It <strong>takes into account the child meshes</strong> when computing the size of the bounding box, so the original mesh and all its children are wrapped.</li>
 <li>We can easily debug collisions by <strong>rendering</strong> the <code>Mesh</code>es that <code>BoxHelper</code> creates. By default they are created with a <code>LineBasicMaterial</code> material (a three.js material for drawing wireframe-style geometries).</li>
</ul>

<p>The main disadvantage is that it <strong>only creates box bounding volumes</strong>, so if you need spheres vs AABB tests you need to create your own <code>Sphere</code> objects.</p>

<p>To use it, we need to create a<strong> </strong>new <code>BoxHelper</code> instance and supply the geometry and — optionally — a color that will be used for the wireframe material. We also need to add the newly created object to the <code>three.js</code> scene in order to render it. We assume our scene variable to be called <code>scene</code>.</p>

<pre class="brush: js notranslate">var knot = new THREE.Mesh(
  new THREE.TorusKnotGeometry(0.5, 0.1),
  new THREE.MeshNormalMaterial({})
);
var knotBoxHelper = new THREE.BoxHelper(knot, 0x00ff00);
scene.add(knotBoxHelper);</pre>

<p>In order to also have our actual <code>Box3</code> bounding box, we create a new <code>Box3</code> object and make it assume the <code>BoxHelper</code>'s shape and position.</p>

<pre class="syntaxbox notranslate">var box3 = new THREE.Box3();
box3.setFromObject(knotBoxHelper);</pre>

<p>If we change the <code>Mesh</code> position, rotation, scale, etc. we need to call the <code>update()</code> method so the <code>BoxHelper</code> instance matches its linked <code>Mesh</code>. We also need to call <code>setFromObject</code> again in order to make the <code>Box3</code> follow the <code>Mesh</code>.</p>

<pre class="syntaxbox notranslate">knot.position.set(-3, 2, 1);
knot.rotation.x = -Math.PI / 4;
// update the bounding box so it stills wraps the knot
knotBoxHelper.update();
box3.setFromObject(knotBoxHelper);</pre>

<p>Performing <strong>collision tests</strong> is done in the same way as explained in the above section — we use our Box3 object in the same way as described above.</p>

<pre class="brush: js notranslate">// box vs box
box3.intersectsBox(otherBox3);
// box vs point
box3.containsPoint(point.position);</pre>

<h3 id="Demos_2">Demos</h3>

<p>There are <strong>two demos</strong> you can take a look at on our <a href="https://mozdevs.github.io/gamedev-js-3d-aabb/">live demos page</a>. The <a href="https://mozdevs.github.io/gamedev-js-3d-aabb/api_point.html">first one</a> showcases point vs. box collisions using <code>BoxHelper</code>. The <a href="https://mozdevs.github.io/gamedev-js-3d-aabb/api_box.html">second one</a> performs box vs. box tests.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/11821/Screen%20Shot%202015-10-19%20at%2012.10.06.png" style="display: block; height: 256px; margin: 0px auto; width: 256px;"></p>
